#ifndef GWt_elementLigneFaisceau_SEEN
#define GWt_elementLigneFaisceau_SEEN

#include "abstractElement.h"
#include "GWt_abstractElement.h"
#include "GWt_dropZoneLigneFaisceau.h"
#include "GWt_pspaApplication.h"

#include <Wt/WContainerWidget>

using namespace Wt;


class GWt_elementLigneFaisceau : public WContainerWidget
{
    public :
    /**
     dropZone element
     a drop zone is the basic element for a widget in the ligne faisceau drop zone area
     it should be like this :
     
     +----------+--------+---------+
     |   (--->) |  ELEM  | (-----) |
     +----------+--------+---------+
     |             NAME            |
     +----------+--------+---------+
     ELEM : Element representation, draggable object
     (----) and (---->) : Droppable zone, contain arrows or line if this element is connected to another
     NAME : editable element name
     
     At first time, the ELEM element is replace by a message.
     */
    
    GWt_elementLigneFaisceau(PspaApplication*);
    GWt_elementLigneFaisceau(typedElement,PspaApplication*);
    
    ~GWt_elementLigneFaisceau();
    void addElement(GWt_abstractElement* elem);
    void setBGColor(const WColor);
    
    inline WText* getElementName() {
        return elementLabel_;
    }
    
    inline WText* getElementIcon() {
        return elementLabel_;
    }
    
    void setElementLabel(std::string label);
    
    inline GWt_dropZoneLigneFaisceau* getDropZoneLeft() {
        return dropZoneLeft_;
    }

    inline GWt_dropZoneLigneFaisceau* getDropZoneRight() {
        return dropZoneRight_;
    }

    inline GWt_abstractElement* getGWt_AbstractElement() {
        return GWt_abstractElement_;
    }

private:
    
    void removeDone(GWt_abstractElement*);
    std::string getElementNumberInBeamLine(nomdElements el);
    void initialize_ligneFaisceau(typedElement eType);
    GWt_dialog* messageDropZone_;
    WText* firstTimeInsertMessage_;
    
    GWt_dropZoneLigneFaisceau* dropZoneLeft_;
    GWt_dropZoneLigneFaisceau* dropZoneRight_;
    WText* elementLabel_;
    PspaApplication* pspa_;
    GWt_abstractElement* GWt_abstractElement_;
    WContainerWidget* elementContainer_;
};
#endif
